﻿package pacotes {


  import pacotes.ObjetoCompilado;

  public class analisaFuncoes {

  protected  var f1Array:Array=["sin","cos","tan","ln","sqrt", "abs", "acos","asin", "atan" ,"ceil", "floor", "round"];
  protected  var f2Array:Array=["max","min","plus","minus","mul","div","pow"];
    
  protected var EhErro:Number;
  protected var mensagemErro:String;	
	
	
  protected var simbValor:String;
  protected var simbTipo:String;
  protected var simbTamanho:Number;

  protected var numeros:String="0123456789.";
  protected var letras:String="abcdefghijklmnopqrstuwvxzy";
  protected var operadores:String="^*+-/(),";
	
  protected var aVarNomes:Array;
  
  public function analisaFuncoes(varArray:Array){
		
		if(varArray.length==0){
			
			this.aVarNomes=[];
			
			} else {
				
		      this.aVarNomes=defineVariaveis(varArray);
		
			}
		
		this.EhErro=0;
	
	    this.mensagemErro="";
		
	}

	
protected function defineVariaveis(v:Array):Array {
	
	var converteNomes:Array=[];
	
	var i:Number;
	
	for(i=0; i<v.length;i++){
			
			if((typeof v[i])!="string"){
				
			    trace("Todas as variáveis devem ser introduzidas como string no construtor analisaFuncoesMatematicas. Não se esqueça das aspas.");
			}
						
				
			converteNomes[i]=v[i].toLowerCase();			
			
		}
			
		
		return converteNomes;
		
}
	

public function Compilar(entradaString:String):ObjetoCompilado {
	
	var coCompObj:ObjetoCompilado=new ObjetoCompilado();
	
	var saltoString:String;
	
	var conString:String;
	
	var fpilha:Array=[];
	
	EhErro=0;
	
	mensagemErro="";
	
	saltoString=brancoEspacos(entradaString);
	
	if(saltoString==""){
		
		coCompObj.PolonesArray=[];
		
		coCompObj.mensagemErro="";
		
		coCompObj.statusErro=0;
		
		return coCompObj;
		
	}
	
	checkLegal(saltoString);
	
	if(EhErro==1){
		
		coCompObj.PolonesArray=[];
		
		coCompObj.mensagemErro=mensagemErro;
		
		coCompObj.statusErro=1;
		
		return coCompObj;
		
		}
	
	checkParenteses(saltoString);
	
	if(EhErro==1){
		
		coCompObj.PolonesArray=[];
		
		coCompObj.mensagemErro=mensagemErro;
		
		coCompObj.statusErro=1;
		
		return coCompObj;
				
		}
	
	checkSimb(saltoString);
	
	if(EhErro==1){
		
		coCompObj.PolonesArray=[];
		
		coCompObj.mensagemErro=mensagemErro;
		
		coCompObj.statusErro=1;
		
		return coCompObj;
		
		
		}
	
	conString=conOperadores(conOperadores(conOperadores(conOperadores(conUnario(conCaret(saltoString)),"/"),"*"),"-"),"+");
    
	if(EhErro==1){
		
		coCompObj.PolonesArray=[];
		
		coCompObj.mensagemErro=mensagemErro;
		
		coCompObj.statusErro=1;
		
		return coCompObj;
		
		}
	
	fpilha=criarPilha(conString);
	
	if(EhErro==1){
		
		coCompObj.PolonesArray=[];
		
		coCompObj.mensagemErro=mensagemErro;
		
		coCompObj.statusErro=1;
		
		return coCompObj;
			
		}
	
	else {
		
		coCompObj.PolonesArray=fpilha;
		
		coCompObj.mensagemErro="";
		
		coCompObj.statusErro=0;
		
		return coCompObj;		
		
		}
	
}



protected function ehSimbf1(chars:String):Boolean {
	
	var i:Number;
	
	for(i=0; i< f1Array.length; i++){
		
	  if(chars == f1Array[i]){return true;}
	  
	}
	
	return false;
}


protected function ehVariavel(chars:String):Boolean {
	
	var i:Number;
	
	for(i=0; i< aVarNomes.length; i++){
		
	  if(chars == aVarNomes[i]){return true;}
	  
	}
	
	return false;
}


protected function ehSimbf2(chars:String):Boolean {
	
	var i:Number;
	
	for(i=0; i< f2Array.length; i++){
		
	  if(chars == f2Array[i]){return true;}
	  
	}
	
	return false;
}


protected function ehLetra(char:String):Boolean {
	
	return letras.indexOf(char) >= 0 ;
	
}


protected function ehOperador(char:String):Boolean {
	
	return operadores.indexOf(char) >= 0 ;
	
}

protected function ehNumerico(char:String):Boolean {
	
	return numeros.indexOf(char) >= 0 ;
	
}

protected function defineSimb(curtype:String,curvalue:String,curlength:Number):void {
	
	simbTipo=curtype;
	
	simbValor=curvalue;
	
	simbTamanho=curlength;
}



protected function pulaSimb(entradaString:String,pos:Number):Boolean {
	
  var char, t, iniTamanho, cpos, cstring;
  
  cstring=entradaString;
  
  cpos=pos;
  
  iniTamanho=entradaString.length;
 
  if(cpos >= iniTamanho || cpos<0){return false; }
  
   else {
	   
        char=cstring.charAt(cpos);
		
		if(ehLetra(char)){
			
		  t=char;
		 
		  do{
			 cpos+=1;
			 
			 if(cpos >= iniTamanho) break;
			 
			 char=cstring.charAt(cpos);
			 
			 if(!ehLetra(char)) break;
						
			 t+=char;
			 
		     }while(1);
	
		  if(ehSimbf1(t)){defineSimb("f1",t, t.length); return true; }
		  
		  else if(ehSimbf2(t)){defineSimb("f2",t, t.length); return true;}
									  
	      else { defineSimb("v",t,t.length); return true;}
			 
		   		
		              }
					  
		 if(ehNumerico(char)){
			
		  t=char;
		 
		  do{
			 cpos+=1;
			 
			 if(cpos >= iniTamanho) break;
			 
			 char=cstring.charAt(cpos);
			 
			 if(!ehNumerico(char)) break;
						
			 t+=char;
			 
		     }while(1);
		
									  
	      defineSimb("n",t,t.length); return true;
			 		   		
		              }
		 
		  if(ehOperador(char)){ 
		    
			   defineSimb("operador",char,1); return true;
		  }
		  
		  
		  return false;
  	
         }
	
}



function checkSimb(entradaString:String):void {
	
	var pstring, piniTamanho, ppos, fpos, bpos, fchar, 
	bchar, contador, casarParenteses, iscomma, comcontador;
		
	pstring=entradaString;
	
	ppos=0;
	
	contador=0;
	
	comcontador=0;
		
	piniTamanho=pstring.length;
	
	if(pstring.indexOf("---")>=0){
		
		carregaErro("Não precisa de tantos menos.");
							 
		return;
		
	} 
	
	while(ppos < piniTamanho && contador<piniTamanho*2){
		
	if(pulaSimb(pstring,ppos)){
		
		    	 fpos=ppos+simbTamanho;
			 
			 fchar=pstring.charAt(fpos);
			 
			 bpos=(ppos-1);
			 
			 bchar=pstring.charAt(bpos);
	
	       if(simbTipo=="f1"){
			 
			 if(!(fchar=="(")){
						   
				carregaErro("'(' esperado na posiçao " + fpos +".");
							 
				return;						   
			    }
				
			 if(ppos > 0 && !(ehOperador(bchar))){
									 
				    carregaErro("Esperado um operador na posiçao " + bpos +".");
							 
				    return;
					
					}
					
			 if(ppos > 0 && bchar==")"){
									 
				    carregaErro("Esperado um operador na posiçao " + bpos +".");
							 
				    return;
					
					}
			
		   }
		   
		   if(simbTipo=="f2"){
			   
			   if(!(simbValor=="max") && !(simbValor=="min")){
				 
				carregaErro("Funções desconecidas na posição " + fpos +".");
							 
				return;
				   
			   }
			   
			   if(!(fchar=="(")){
						   
				carregaErro("'(' esperado na posiçao " + fpos +".");
							 
				return;
				
			    } else {
					
					casarParenteses=1; iscomma=0; comcontador=0;
					
					while(casarParenteses>0 && comcontador<piniTamanho){
						
					   comcontador+=1;
					   
					   if(pstring.charAt(fpos+comcontador)=="("){casarParenteses+=1;}
				   
				           if(pstring.charAt(fpos+comcontador)==")"){casarParenteses+=-1;}
					   
					   if(pstring.charAt(fpos+comcontador)==","){iscomma+=1;}
						
					}
					
					if(iscomma==0){
						
				             carregaErro("Esperados dois argumento para a função na posição " + ppos +".");
							 
				             return;
												
					}
										
				}
			 
			 if(ppos > 0 && !(ehOperador(bchar))){
									 
					carregaErro("Esperado um operador na posiçao " + bpos +".");
							 
				    return;
					
					}
					
			if(ppos > 0 && bchar==")"){
									 
					carregaErro("Esperado um operador na posiçao " + bpos +".");
							 
				        return;
					
					}
						
		   }
		   
		   if(simbTipo=="v"){
			
			if(!(ehVariavel(simbValor) || simbValor=="pi" || simbValor=="e")){
				
				carregaErro("Entradas desconhecidas na posição " + ppos +".");
							 
				return;
				
			}
			
			if(ppos > 0 && !(ehOperador(bchar))){
									 
					carregaErro("Esperado um operador na posiçao " + bpos +".");
							 
				        return;
					
					}
					
			if(ppos > 0 && bchar==")"){
									 
					carregaErro("Esperado um operador na posiçao " + bpos +".");
							 
				        return;
					
					}
					
			if(fpos < piniTamanho && !(ehOperador(fchar))){
									 
					carregaErro("Esperado um operador na posiçao " + fpos +".");
							 
				        return;
					
					}
					
			if(fpos < piniTamanho && fchar=="("){
									 
					carregaErro("Esperado um operador na posiçao " + fpos +".");
							 
				        return;
					
					}
			
		   }
		   
		   if(simbTipo=="n"){
			   
			   if(ppos > 0 && !(ehOperador(bchar))){
									 
					carregaErro("Esperado um operador na posiçao " + bpos +".");
							 
				        return;
					
					}
					
			if(ppos > 0 && bchar==")"){
									 
					carregaErro("Esperado um operador na posiçao " + bpos +".");
							 
				        return;
					
					}
					
			if(fpos < piniTamanho && !(ehOperador(fchar))){
									 
					carregaErro("Esperado um operador na posiçao " + fpos +".");
							 
				        return;
					
					}
					
			if(fpos < piniTamanho && fchar=="("){
									 
					carregaErro("Esperado um operador na posiçao " + fpos +".");
							 
				        return;
					
					}
			
		      }
			  
		if(simbValor=="("){
						 
			       if(fpos < piniTamanho && ("^*,)+/").indexOf(fchar)>=0){
									 
					carregaErro("Entradas esperadas na posição " + fpos +".");
							 
				        return;
					
					}
					
										
				}
				
	    if(simbValor==")"){
				  
				   if(fpos < piniTamanho && ("^*+-,/)").indexOf(fchar)==-1){
									 
					carregaErro("Entradas esperadas na posição " + fpos +".");
							 
				        return;
					
					}
					
					if(bpos >=0 && ("^*+-,/(").indexOf(bchar)>=0){
									 
					carregaErro("Entradas esperadas na posição " + fpos +".");
							 
				        return;
					
					}
				
				
				 }
				 
		if(simbValor==","){
			
			       if(ppos==0 || ppos==piniTamanho-1){
					   
					carregaErro("Vírgula dispersa na posição " + ppos +".");
							 
				        return;
					   
					   
				   }
				  
				   if(fpos < piniTamanho && ("^*+,/)").indexOf(fchar)>=0){
									 
					carregaErro("Entradas esperadas na posição  " + fpos +".");
							 
				        return;
					
					}
					
					if(bpos >=0 && ("^*+-,/(").indexOf(bchar)>=0){
									 
					carregaErro("Entradas esperadas na posição  " + fpos +".");
							 
				        return;
					
					}
				
				
				 }
				 
		  if(("^/*-+").indexOf(simbValor)>=0){
			  
			 if(("+*^/),").indexOf(fchar)>=0){
				 
				 carregaErro("Entradas esperadas na posição  " + fpos +".");
							 
				 return;
			 
			 }
			 
			 if(("+*^/(,").indexOf(bchar)>=0 && !(simbValor=="-")){
				 
				 carregaErro("Entradas esperadas na posição  " + fpos +".");
							 
				 return;
			 
			 }
			 
			 
			  
		  }
		
						 
	
	}
	
	else {carregaErro("Caracteres desconhecidos na posição ." + ppos);}
	
	ppos+=simbTamanho;
	
	contador+=1;

    }
	
}

	


protected function conOperadores(entradaString:String, char:String):String {

  var tranString, iniTamanho, mco, atualpos, esquerdaOper, direitaOper, esquerdaMove, direitaMove;

  iniTamanho=entradaString.length;
  
  tranString=entradaString;
  
  if(tranString.indexOf(char)==-1){
		
        return tranString;}
		
   else if(tranString.indexOf(char)==0 && !(char=="-")){
		
		carregaErro("Erro no primeiro " + char);
		
        return "";}
		
   else if(tranString.charAt(tranString.length-1)==char){
		
		carregaErro("Erro no último " + char + ".");
				
        return "";}
				
   else{mco=0;
			
   while(tranString.indexOf(char)>0 && mco<iniTamanho*6){
	   
	   mco+=1;
   
	   atualpos=tranString.indexOf(char);
	 
	   esquerdaMove=irParaEsquerda(tranString,atualpos);
	   
	   if(EhErro==1){
		   
		   carregaErro("Erro em  " + char + "  number " + mco + ".");
		   
		   return ""; } 
		   
		else { esquerdaOper=tranString.substring(esquerdaMove+1,atualpos); }
		
		direitaMove=irParaDireita(tranString,atualpos);
	   
	   if(EhErro==1){
		   
		   carregaErro("Erro em  " + char + "  number " + mco + ".");
		   
		   return ""; } 
		   
		else { direitaOper=tranString.substring(atualpos+1, direitaMove); }
		
		if(char=="*"){
		
	   tranString=tranString.substring(0,esquerdaMove+1)
	           +"mul("+ esquerdaOper+ "," + direitaOper + ")" + 
	   tranString.substring(direitaMove,tranString.length+1);
		}
		
		if(char=="/"){
		
	   tranString=tranString.substring(0,esquerdaMove+1)
	           +"div("+ esquerdaOper+ "," + direitaOper + ")" + 
	   tranString.substring(direitaMove,tranString.length+1);
		}
		
		if(char=="-"){
		
	   tranString=tranString.substring(0,esquerdaMove+1)
	           +"minus("+ esquerdaOper + "," + direitaOper + ")" + 
	   tranString.substring(direitaMove,tranString.length+1);
		}
		
		if(char=="+"){
		
	   tranString=tranString.substring(0,esquerdaMove+1)
	           +"plus("+ esquerdaOper + "," + direitaOper + ")" + 
	   tranString.substring(direitaMove,tranString.length+1);
		}
	   
	   if(tranString.length>iniTamanho*7){
		 
		 carregaErro("Oooopa!");
		 
		 return "";}
}
		
	return tranString;
   }
		
}


protected function conUnario(entradaString:String):String {
		
  var tranString, iniTamanho, mco, atualpos, i, j;
     
  iniTamanho=entradaString.length;
  
  tranString=entradaString;
  
  if(tranString.indexOf("-")==-1){
	    
          return tranString;}
		
  if(tranString.charAt(tranString.length-1)=="-"){
	  
	  carregaErro("Erro no último minus.");
	  
	  return "";}

  for(i=0; i<tranString.length; i++){
	   
	   if(tranString.charAt(i)=="-" && unarioId(tranString.charAt(i-1)))
	    {    
		   j=irParaDireita(tranString, i);
		   
		   if(EhErro==1){
		   
		   carregaErro("Erro na posição " + i);
		   
		   return ""; }
		   
		   tranString=tranString.substring(0,i)+"minus(0,"+tranString.substring(i+1,j) + ")" + tranString.substring(j,tranString.length);
				
		}
		
		if(tranString.length > 9*iniTamanho){
			
			carregaErro("Oooopa!");
		
			return "";}
	  
  }

 
  return tranString;
	
}

protected function unarioId(char:String):Boolean { 

    if("+-,(/*^".indexOf(char)>-1){return true;} 
					
	 else {return false;}
}


protected function irParaDireita(entradaString:String, pos:Number):Number {
	
	var direitaChar, direitaContador, casarParenteses;
	
	direitaChar=entradaString.charAt(pos+1);
	
	direitaContador=pos+1;
	
if(direitaChar=="-"){
	   
	    direitaContador+=1; 
	   
        if(direitaContador>=entradaString.length){
	    
		EhErro=1;
		
		return direitaContador;}
		
		else{
			
	    direitaChar=entradaString.charAt(direitaContador);}
  }
  

if(numeros.indexOf(direitaChar)>-1){ 

while(numeros.indexOf(entradaString.charAt(direitaContador))>-1 
		&& direitaContador<entradaString.length)
		   { 
		     direitaContador+=1;
		   }
		   
		  }
		  
else if(letras.indexOf(direitaChar)>-1){
   
  while(letras.indexOf(entradaString.charAt(direitaContador))>-1 
		   && direitaContador<entradaString.length)
		   {
			  direitaContador+=1;		   
		   }
	
		   
     if(entradaString.charAt(direitaContador)=="("){
							
	  casarParenteses=1;
		
      while(casarParenteses>0 && direitaContador<entradaString.length)
		   {  
			  direitaContador+=1;
			  
		  if(entradaString.charAt(direitaContador)=="("){casarParenteses+=1;}
												
		  if(entradaString.charAt(direitaContador)==")"){casarParenteses+=-1;} 
		   }
		  		
		}
				
	if(casarParenteses>0){
		
			EhErro=1;
			
			return direitaContador;
			
			}
			
		  }
		  
		  
 else if(direitaChar=="("){
			
	  casarParenteses=1;
			
      while(casarParenteses>0 && direitaContador<entradaString.length)
		   {  
		      direitaContador+=1;
		   
			  if(entradaString.charAt(direitaContador)=="("){casarParenteses+=1;}
													
		      if(entradaString.charAt(direitaContador)==")"){casarParenteses+=-1;}
			  
		   }
		   direitaContador+=1;
		   
		   
		   if(casarParenteses>0){
		    
			EhErro=1;
			
			return direitaContador;}
		  }
		  
 else { 
			EhErro=1;
			  
			return direitaContador;}
			  
return direitaContador;
	
}




protected function irParaEsquerda(entradaString:String,pos:Number):Number {
	
	var esquerdaChar, esquerdaContador, casarParenteses;
	
	esquerdaChar=entradaString.charAt(pos-1);
	
	esquerdaContador=pos-1;
	
if(numeros.indexOf(esquerdaChar)>-1){
		   
     while(numeros.indexOf(entradaString.charAt(esquerdaContador))>-1 && esquerdaContador>=0)
		   { 		   		     
		   esquerdaContador+=-1; 
		   }
		   
     }
		  
else if(letras.indexOf(esquerdaChar)>-1){
		   
     while(letras.indexOf(entradaString.charAt(esquerdaContador))>-1 && esquerdaContador>=0)
		   { 		   		     
		   esquerdaContador+=-1; 
		   }
	      
		  }
   

else if(esquerdaChar==")"){
	  
	  casarParenteses=1;
  
     if(esquerdaContador==0){
						 EhErro=1;
						 
						 return esquerdaContador;}
						 
						 
       while(casarParenteses>0 && esquerdaContador>0)
		   {
		   esquerdaContador+=-1;
		   
		   if(entradaString.charAt(esquerdaContador)==")"){casarParenteses+=1;}
		   
		   if(entradaString.charAt(esquerdaContador)=="("){casarParenteses+=-1;}		   
		   }
		   esquerdaContador+=-1;
		   
	  if(casarParenteses>0){
	 
	        EhErro=1;
			
			return esquerdaContador;
			}
		   
      if(esquerdaContador>=0 && numeros.indexOf(entradaString.charAt(esquerdaContador))>-1){
	
					EhErro=1;
					
					return esquerdaContador;}
						 
      if(esquerdaContador==0 && !(entradaString.charAt(esquerdaContador)=="-")
							&& !(entradaString.charAt(esquerdaContador)=="(")){
	
	                EhErro=1;
	  
	                return esquerdaContador;}
	
     if(esquerdaContador>0 && letras.indexOf(entradaString.charAt(esquerdaContador))>-1){
		   
     while(letras.indexOf(entradaString.charAt(esquerdaContador))>-1 && esquerdaContador>=0)
		   { 		   
		   esquerdaContador+=-1; 		   
		   }
 
		  }
		    			
		}		  


 else {
		
		EhErro=1;
		
		return esquerdaContador;
		
		}
		
		
return esquerdaContador;
		
	
}




protected function conCaret(entradaString:String):String {

var tranString, iniTamanho, mco, atualpos, esquerdaMove,
direitaMove, base, expoente;

  iniTamanho=entradaString.length;
  
  tranString=entradaString;
  
  if(tranString.indexOf("^")==-1){
		
        return tranString;}
		
   else if(tranString.indexOf("^")==0){
		
		carregaErro("Erro no primeiro ^.");
		
        return "";}
		
   else if(tranString.charAt(tranString.length-1)=="^"){
		
		carregaErro("Erro no primeiro ^.");
				
        return "";}
				
   else{mco=0;
			
   while(tranString.indexOf("^")>0 && mco<iniTamanho*6){
	   
	   mco+=1;
   
	   atualpos=tranString.lastIndexOf("^");
	 
	   esquerdaMove=irParaEsquerda(tranString,atualpos);
	   
	   if(EhErro==1){
		   
		   carregaErro("Erro em ^ número " + mco + " do final.");
		   
		   return ""; } 
		   
		else { base=tranString.substring(esquerdaMove+1,atualpos); }
		
		direitaMove=irParaDireita(tranString,atualpos);
	   
	   if(EhErro==1){
		   
		   carregaErro("Erro em ^ número " + mco + " do final.");
		   
		   return ""; } 
		   
		else { expoente=tranString.substring(atualpos+1, direitaMove); }
		
	   tranString=tranString.substring(0,esquerdaMove+1)
	           +"pow("+ base+ "," + expoente + ")" + 
	   tranString.substring(direitaMove,tranString.length+1);
	   
	   if(tranString.length>iniTamanho*7){
		 
		 carregaErro("Oooopa!");
	
		 return "";}
}
		
	return tranString;
   }
		
}


protected function brancoEspacos(entradaString:String):String {

   var atualpos, tranString, iniTamanho, contador=0;
   
   iniTamanho=entradaString.length;
   
   tranString=entradaString.toLowerCase();
   
   while(tranString.indexOf(" ")>-1 && contador < iniTamanho+1){
	   
	 atualpos=tranString.indexOf(" ");
	 
	 tranString=tranString.substring(0,atualpos) + 
	 tranString.substring(atualpos+1,tranString.length);
	   
	 contador+=1;
	
   }

   return tranString;
		
}


protected function checkLegal(entradaString:String):Boolean {
	
	  var i, legal, atualchar;

      if(entradaString==""){
	   
	  carregaErro("Empty input.");
	   
	  return false;}
	   
      for(i=0; i<entradaString.length; i++){
	
      atualchar=entradaString.charAt(i);
	
      legal=numeros.indexOf(atualchar)+letras.indexOf(atualchar)+operadores.indexOf(atualchar);

      if(legal==-3){
	   
	      carregaErro("Caracteres desconhecidos.");
	 
	      return false;}
	 
   }
      return true;	
}


protected function checkParenteses(entradaString:String):Boolean {
	
	var i, j, casarParenteses, esquerda=0, direita=0, contador=0;
	
	for(i=0; i<entradaString.length; i++){
		
		if(entradaString.charAt(i)=="("){esquerda+=1;}
									
		if(entradaString.charAt(i)==")"){direita+=1;}
	}
		
		if(!(esquerda==direita)){
			
			carregaErro("Parênteses incompatíveis");
			
			return false;}
			
	for(j=0; j<entradaString.length; j++){
			
		if(entradaString.charAt(j)=="("){
									
	    casarParenteses=1; contador=0;
			
        while(casarParenteses>0 && contador<entradaString.length)
		   {  
		      contador+=1;
			  
			  if(entradaString.charAt(j+contador)=="("){casarParenteses+=1;}
													
		      if(entradaString.charAt(j+contador)==")"){casarParenteses+=-1;}
			  
		   }
		  
		   if(casarParenteses>0){
			   
			j+=1;
		    
			carregaErro("Parênteses incompatíveis na posição número" + j); 
			
			return false;
			
			}
			
		  }
					
		}
		
		
		for(j=0; j<entradaString.length; j++){
			
		if(entradaString.charAt(j)==")"){
					
	    casarParenteses=1; contador=0;
			
        while(casarParenteses>0 && contador<entradaString.length)
		   {  
		      contador+=1;
			  
			  if(entradaString.charAt(j-contador)==")"){casarParenteses+=1;}
													
		      if(entradaString.charAt(j-contador)=="("){casarParenteses+=-1;}
			  
		   }
		   
	
		   if(casarParenteses>0){
			   
			j+=1;
		    
			carregaErro("parênteses incompatíveis no número de posição " + j); 
			
			return false;
			
			}
			
		  }
					
		}
			
		return true;
}



protected function criarPilha(entradaString:String):Array {
	
	var cString, mIniTamanho, cPos, cPilha, checkpilha, 
	checkExpressao, contador, checkResultado;
		
	cString=entradaString;
	
	cPos=0;
	
	cPilha=[];
	
	checkpilha=[];
	
	mIniTamanho=cString.length;
	
	checkExpressao=[];
	
	checkResultado=[];
	
	contador=0;
	

	while(cPos < mIniTamanho && contador<mIniTamanho*2){
		
	if(pulaSimb(cString,cPos)){
	
	       if(simbTipo=="f1"){
			
			 cPilha.push(this[simbValor]);
			 
			 cPilha.push("f1");
			 
			checkpilha.push(this["sin"]);
	
			checkpilha.push("f1");
			
		   }
		   
		   if(simbTipo=="f2"){
			
			 cPilha.push(this[simbValor]);
			 
			 cPilha.push("f2");
			 
			checkpilha.push(this["plus"]);
			 
			checkpilha.push("f2");
			
		   }
		   
		   if(simbTipo=="v"){
			
			 cPilha.push(simbValor);
			 
			 cPilha.push("v");
			 
			 checkpilha.push("x");
			 
			 checkpilha.push("v");
			
		   }
		   
		   if(simbTipo=="n"){
			
			 cPilha.push(Number(simbValor));
			 
			 cPilha.push("n");
			 
			checkpilha.push(Number(simbValor));
			 
			checkpilha.push("n");
			
		   }
	
	}
	
	else {carregaErro("Caracteres desconhecidos"); return [];}
	
	cPos+=simbTamanho;
	
	contador+=1;

}


cPilha.reverse();

checkExpressao=checkpilha.reverse();

checkAvaliar(checkExpressao);

if(EhErro==1){return [];}

return(cPilha);
	
}


protected function carregaErro(mens:String):void {
      
	  mensagemErro="Erro de sintaxe." + mens;
	  
	  EhErro=1;
	
}


protected function checkAvaliar(compiladaExpressao:Array):void {


	var entradaTipo="";

	var operadores=[];
	
	var arg1, arg2;

	for( var i = 0; i < compiladaExpressao.length; i++){

		entradaTipo = compiladaExpressao[i++];

		if(entradaTipo == "n"){
			
			operadores.push(compiladaExpressao[i]);
	
		} else if( entradaTipo == "v"){
			
			operadores.push(1);
					
		}  else if( entradaTipo == "f1"){
			
			if(operadores.length<1){carregaErro("Verifique o número de argumentos em suas funções."); return;}

			operadores.push(compiladaExpressao[i](operadores.pop()))
		
		} else if( entradaTipo == "f2"){
			
			if(operadores.length<2){carregaErro("Verifique o número de argumentos em suas funções."); return;}
					
			arg1=operadores.pop();
                        arg2=operadores.pop();
			operadores.push(compiladaExpressao[i](arg1,arg2));				

		} else {

		 carregaErro("Não pode avaliar."); return;

		}

		
	}
     
	
	if(!(operadores.length==1)){
	
	carregaErro(""); 
	
	return;
}

if(isNaN(operadores[0])){

	carregaErro(""); 
	
	return;
}
	
}




protected function sin(a){
	
	return Math.sin(a);
	
}



protected function cos(a){
	
	return Math.cos(a);
	
}


protected function tan(a){
	
	return Math.tan(a);
	
}


protected function ln(a){
	
	return Math.log(a);
	
}


protected function sqrt(a){
	
	return Math.sqrt(a);
	
}


protected function abs(a){
	
	return Math.abs(a);
	
}


protected function asin(a){
	
	return Math.asin(a);
	
}

protected function acos(a){
	
	return Math.acos(a);
	
}


protected function atan(a){
	
	return Math.atan(a);
	
}



protected function floor(a){
	
	return Math.floor(a);
	
}



protected function ceil(a){
	
	return Math.ceil(a);
	
}

protected function round(a){
	
	return Math.round(a);
	
}


protected function max(a,b){
	
	return Math.max(a,b);
	
}


protected function min(a,b){
	
	return Math.min(a,b);
	
}


protected function plus(a,b){

	return a + b;

}




protected function minus(a,b){

	return a - b;

}



protected function mul(a,b){

	return a * b;

}


protected function div(a,b){

	return a / b;

}



protected function  pow(a, b) {

   
    if (a<0 && b==Math.floor(b)){

        if((b % 2)==0){return Math.pow(-a, b);}

        else {return -Math.pow (-a, b);}

    }
	
	 if (a==0 && b>0){return 0;}
	 
	 if(isNaN(a) && b==0){
		 
		return NaN;
		
	 }

    return Math.pow (a, b);

}



public function avaliarExpressoes(compiladaExpressao:Array,aVarValores:Array): Number {

	var entradaTipo:String="";

	var operadores:Array=[];
	
	var i:Number;
	
	var j:Number;
	
	var arg0;
	
	var arg1;
	
	var arg2;
	
	if(aVarValores.length!=aVarNomes.length){
		
		return NaN; 
		
	}
	
	for(j = 0; j < aVarValores.length; j++){
		
		if((typeof aVarValores[j])!="number"){
			
			return NaN;
			
		}
		
	}

	for(i = 0; i < compiladaExpressao.length; i++){

		entradaTipo = compiladaExpressao[i++];

		if(entradaTipo == "n"){
			
			operadores.push(compiladaExpressao[i]);

		} else if( entradaTipo == "v"){
						
			if(compiladaExpressao[i]=="e"){
				
				operadores.push(Math.E);
				
			} else if(compiladaExpressao[i]=="pi"){
				
				operadores.push(Math.PI);
				
				}
				
		  else {
		
		for(j=0; j<aVarNomes.length; j++){
			
			if(compiladaExpressao[i]==aVarNomes[j]){
				
				operadores.push(aVarValores[j]);
				
			}
			
		}
		
	}
			
			
		}  else if( entradaTipo == "f1"){
			
	
			arg0=operadores.pop();
			
			
			if(compiladaExpressao[i]==sin){
				
				operadores.push(Math.sin(arg0));
				
				
			} 
			
			else if(compiladaExpressao[i]==cos){
				
				operadores.push(Math.cos(arg0));
				
				
			} 
			
			else if(compiladaExpressao[i]==tan){
				
				operadores.push(Math.tan(arg0));
				
				
			}
			
			else if(compiladaExpressao[i]==asin){
				
				operadores.push(Math.asin(arg0));
				
				
			}
			
			else if(compiladaExpressao[i]==acos){
				
				operadores.push(Math.acos(arg0));
				
				
			}
			
			else if(compiladaExpressao[i]==atan){
				
				operadores.push(Math.atan(arg0));
				
				
			}
			
			else if(compiladaExpressao[i]==ln){
				
				operadores.push(Math.log(arg0));
							
			}
			
			else if(compiladaExpressao[i]==sqrt){
				
				operadores.push(Math.sqrt(arg0));
				
				
			}
			
			else if(compiladaExpressao[i]==abs){
				
				operadores.push(Math.abs(arg0));
				
				
			}
			
			else if(compiladaExpressao[i]==ceil){
				
				operadores.push(Math.ceil(arg0));
				
				
			}
			
			else if(compiladaExpressao[i]==floor){
				
				operadores.push(Math.floor(arg0));
				
				
			}
			
			else if(compiladaExpressao[i]==round){
				
				operadores.push(Math.round(arg0));
				
				
			}
			
			else {
					
			operadores.push(compiladaExpressao[i](arg0));
			
			}
			

		} else if(entradaTipo == "f2"){
			
			arg1=operadores.pop(); arg2=operadores.pop();
			
			
			if(compiladaExpressao[i]==mul){
				
				operadores.push(arg1*arg2);
				
				
			} 
			
			else if(compiladaExpressao[i]==plus){
				
				operadores.push(arg1+arg2);
				
				
			} 
			
			else if(compiladaExpressao[i]==minus){
				
				operadores.push(arg1-arg2);
				
				
			}
			
			else if(compiladaExpressao[i]==div){
				
				operadores.push(arg1/arg2);
				
				
			}
			
			else if(compiladaExpressao[i]==pow){
				
				operadores.push(Math.pow(arg1,arg2));
				
				
			}
			
			else if(compiladaExpressao[i]==min){
				
				operadores.push(Math.min(arg1,arg2));
				
				
			}
			
			else if(compiladaExpressao[i]==max){
				
				operadores.push(Math.max(arg1,arg2));
							
			}
			
			else {
			
			operadores.push(compiladaExpressao[i](arg1,arg2));	
			
			}
			

		} else {

			return NaN;

		}
		
	}
	
	return operadores[0]

}



                // ------------------------------------------------

	        // Método de derivação de funções de uma única variável.


		public function derivar(compiladaExpressao:Array,aVarValores:Array):Number {
			 

			if (aVarValores.length > 1) {
				return (NaN);
			}
			
			var entradaTipo:String="";
			var operadores:Array=[];
			
			var i:Number;
			var j:Number;
			
			var arg0:Array;
			var arg1:Array;
			var arg2:Array;
			
			if(aVarValores.length!=aVarNomes.length){
				return NaN; 
			}
			
			for(j = 0; j < aVarValores.length; j++){
				if((typeof aVarValores[j])!="number"){
					return NaN;
				}
			}
			
			for(i = 0; i < compiladaExpressao.length; i++){
				entradaTipo = compiladaExpressao[i++];
				
				if(entradaTipo == "n"){
					operadores.push( [ compiladaExpressao[i], 0 ]);
				} 
				else if (entradaTipo == "v"){
					if(compiladaExpressao[i]=="e"){
						operadores.push( [ Math.E, 0 ] );
						
					} 
					else if(compiladaExpressao[i]=="pi"){
						operadores.push( [ Math.PI, 0 ] );
					}
	
				  else {
					  for(j=0; j<aVarNomes.length; j++){
						  if(compiladaExpressao[i]==aVarNomes[j]){
							  operadores.push( [ aVarValores[j], 1 ] );
						  }
					  }
				  }
				}
				else if( entradaTipo == "f1"){
					
					arg0=operadores.pop();
					if(compiladaExpressao[i]==sin){
						operadores.push( [ Math.sin(arg0[0]), Math.cos(arg0[0])*arg0[1] ] );
					} 
					
					else if(compiladaExpressao[i]==cos){
						operadores.push( [ Math.cos(arg0[0]), -Math.sin(arg0[0])*arg0[1] ] );
					} 
					
					else if(compiladaExpressao[i]==tan){
						operadores.push( [ Math.tan(arg0[0]), arg0[1]/(Math.cos(arg0[0])*Math.cos(arg0[0])) ] );
					}
					
					else if(compiladaExpressao[i]==asin){
						operadores.push( [ Math.asin(arg0[0]), arg0[1]/Math.cos(Math.asin(arg0[0])) ] );
					}
					
					else if(compiladaExpressao[i]==acos){
						operadores.push( [ Math.acos(arg0[0]), -arg0[1]/Math.sin(Math.acos(arg0[0])) ] );
					}
					
					else if(compiladaExpressao[i]==atan){
						operadores.push( [ Math.atan(arg0[0]), arg0[1]*Math.cos(Math.atan(arg0[0]))*Math.cos(Math.atan(arg0[0])) ] );
					}
					
					else if(compiladaExpressao[i]==ln){
						operadores.push( [ Math.log(arg0[0]), arg0[1]/arg0[0] ] );
					}
					
					else if(compiladaExpressao[i]==sqrt){
						operadores.push( [ Math.sqrt(arg0[0]), arg0[1]/(2*Math.sqrt(arg0[0])) ] );
					}
					
					else if(compiladaExpressao[i]==abs){
						operadores.push( [ Math.abs(arg0[0]), NaN ] );
					}
					
					else if(compiladaExpressao[i]==ceil){
						operadores.push( [ Math.ceil(arg0[0]), NaN ] );
					}
					
					else if(compiladaExpressao[i]==floor){
						operadores.push( [ Math.floor(arg0[0]), NaN ] );
					}
					
					else if(compiladaExpressao[i]==round){
						operadores.push( [ Math.round(arg0[0]), NaN ] );
					}
					
					else {
						operadores.push(compiladaExpressao[i](arg0));
						}
				}
				else if(entradaTipo == "f2"){
					
					arg1=operadores.pop(); 
					arg2=operadores.pop();
					
					if(compiladaExpressao[i]==mul){
						operadores.push( [ arg1[0]*arg2[0], arg1[1]*arg2[0] + arg1[0]*arg2[1] ] );
					} 
					
					else if(compiladaExpressao[i]==plus){
						operadores.push( [ arg1[0]+arg2[0], arg1[1]+arg2[1] ] );
					}
					
					else if(compiladaExpressao[i]==minus){
						operadores.push( [ arg1[0]-arg2[0], arg1[1]-arg2[1] ] );
					}
					
					else if(compiladaExpressao[i]==div){
						operadores.push( [ arg1[0]/arg2[0], (arg2[0]*arg1[1]-arg2[1]*arg1[0])/(arg2[0]*arg2[0]) ] );
					}
					
					else if(compiladaExpressao[i]==pow){
						if (arg2[1] == 0) {
							operadores.push( [ Math.pow(arg1[0],arg2[0]), Math.pow(arg1[0],arg2[0]-1)*arg2[0]*arg1[1] ] );
						}
						else {
							operadores.push( [ Math.pow(arg1[0],arg2[0]), Math.pow(arg1[0],arg2[0]-1)*(arg2[0]*arg1[1] + arg1[0]*arg2[1]*Math.log(arg1[0]) ) ] );
						}
					}
	
					else if(compiladaExpressao[i]==min){
						operadores.push( [ Math.min(arg1[0],arg2[0]), NaN ] );
					}
					
					else if(compiladaExpressao[i]==max){
						operadores.push( [ Math.max(arg1[0],arg2[0]), NaN ] );
					}
					
					else {
						operadores.push(compiladaExpressao[i](arg1,arg2));
					}
				} else {
					return NaN;
				}
			}
			return operadores[0][1];
		}

                //  ------------------------------------------------

}

}
